#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

FILE *pf29,*pf30,*pf31,*pf32;


void echanger(double ranger[], int a, int b)
{
    double temp = ranger[a];
    ranger[a] = ranger[b];
    ranger[b] = temp;
}

void quickSort(double ranger[], int debut, int fin)
{
    int gauche = debut-1;
    int droite = fin+1;
    const double pivot = ranger[debut];
    
    /* Si le tableau est de longueur nulle, il n'y a rien à faire. */
    if(debut >= fin)
        return;
    
    /* Sinon, on parcourt le tableau, une fois de droite à gauche, et une
     autre de gauche à droite, à la recherche d'éléments mal placés,
     que l'on permute. Si les deux parcours se croisent, on arrête. */
    while(1)
    {
        do droite--; while(ranger[droite] > pivot);
        do gauche++; while(ranger[gauche] < pivot);
        
        if(gauche < droite)
            echanger(ranger, gauche, droite);
        else break;
    }
    
    /* Maintenant, tous les éléments inférieurs au pivot sont avant ceux
     supérieurs au pivot. On a donc deux groupes de cases à trier. On utilise
     pour cela... la méthode quickSort elle-même ! */
    quickSort(ranger, debut, droite);
    quickSort(ranger, droite+1, fin);
}


int main(){
    float ran2(long int*);
    int i, j, k,l;
    int L = 50;
    int N = 20;
    long int idum = -1833;
    double x[N];
    double ranger[N];
    double hist_premiervoisin[L];
    double premiervoisin[N-1];
    
    
    for(i=0;i<L;i++){
        hist_premiervoisin[i] = 0;
    }
    
    pf29 = fopen("traj_bosons.txt","w");
    pf30 = fopen("ranger_traj_bosons.txt","w");
    pf31 = fopen("premiervoisins_bosons.txt","w");
    pf32 = fopen("hist_premiervoisins_bosons.txt","w");
    
    for(k=0 ; k<10000000; k++){
        for(j=0;j<N;j++){
            x[j] = 20*(ran2(&idum));
            fprintf(pf29,"%lf ",x[j]);
        }
        fprintf(pf29,"\n");
    }
    fclose(pf29);
    
    
    pf29 = fopen("traj_bosons.txt","r");
    
    for(i=0;i<10000000;i++){
        
        for(j=0;j<N;j++){
            fscanf(pf29,"%lf ",&ranger[j]);
        }
        
        //APPEL DU TRI//
        quickSort(ranger, 0, N-1);
        
        for(j = 0; j < N; j++)
        {
            fprintf(pf30,"%lf ",ranger[j]);
        }
        fprintf(pf30,"\n");
        fscanf(pf29,"\n");
        
        //-------------------//
    }//endfor i
    fclose(pf30);
    
    //--------Premier Voisin-----------//
    
    
    pf30 = fopen("ranger_traj_bosons.txt","r");
    
    for(i=0;i<10000000;i++){
        
        for(j=0;j<N;j++){
            fscanf(pf30,"%lf ",&x[j]);
        }
        
        for(j=0;j<N-1;j++){
            premiervoisin[j] = x[j+1]-x[j];
            fprintf(pf31,"%lf ",premiervoisin[j]);
            for(l=0; l<L;l++){
                if(l*3/(double)L<=premiervoisin[j] && premiervoisin[j]<=(l+1)*3/(double)L){
                    hist_premiervoisin[l] = hist_premiervoisin[l]+1;
                }//endif
            }//endfor l
        }//endfor j
        
        fprintf(pf30,"\n");
        fscanf(pf29,"\n");
        
        
    }//endfor i
    
    
    for(l=0;l<L;l++){
        fprintf(pf32,"%lf %lf\n ",(l*3/(double)L+(l+1)*3/(double)L)/2,hist_premiervoisin[l]);
    }

    
    fclose(pf30);
    fclose(pf29);
    fclose(pf31);
    fclose(pf32);
    
}//endmain