#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

FILE *pf2,*pf23,*pf25,*pf26,*pf27,*pf28;

float ran2(long int*);
int i,j,k,l,a,N = 20, nbredefois = 100000 ;
int compteur;
int iout, mod;
int M = 1001; //sur un intervalle de [-4,4]

double P, newP, newX, intervalle;
long int idum = -1833;


double pas;


void echanger(double ranger[], int a, int b)
{
    double temp = ranger[a];
    ranger[a] = ranger[b];
    ranger[b] = temp;
}

void quickSort(double ranger[], int debut, int fin)
{
    int gauche = debut-1;
    int droite = fin+1;
    const double pivot = ranger[debut];
    
    /* Si le tableau est de longueur nulle, il n'y a rien à faire. */
    if(debut >= fin)
        return;
    
    /* Sinon, on parcourt le tableau, une fois de droite à gauche, et une
     autre de gauche à droite, à la recherche d'éléments mal placés,
     que l'on permute. Si les deux parcours se croisent, on arrête. */
    while(1)
    {
        do droite--; while(ranger[droite] > pivot);
        do gauche++; while(ranger[gauche] < pivot);
        
        if(gauche < droite)
            echanger(ranger, gauche, droite);
        else break;
    }
    
    /* Maintenant, tous les éléments inférieurs au pivot sont avant ceux
     supérieurs au pivot. On a donc deux groupes de cases à trier. On utilise
     pour cela... la méthode quickSort elle-même ! */
    quickSort(ranger, debut, droite);
    quickSort(ranger, droite+1, fin);
}


int main() {
    
    pf2 = fopen("traj.txt","w");
    pf23 = fopen("fctcomptage.txt","w");
    pf25 = fopen("traj_uniforme.txt","w");
    pf26 = fopen("ranger_traj_uniforme.txt","w");
    pf27 = fopen("premiervoisin.txt","w");
    pf28 = fopen("hist_premiervoisin.txt","w");
    
    double xmax = 8.0 ;
    double xmin = -xmax;
    double x[N];
    double premiervoisin[N-1];
    double fctcomptage[M];
    double hist_premiervoisin[M];
    double ranger[N];
    
    pas = (xmax-xmin)/M;
    printf("pas %f\n",pas);
    
    //initialisation tableaux//
    for(i=0;i<M;i++){

        fctcomptage[i] = 0;
        hist_premiervoisin[i] = 0;
    }
    
    
    
    compteur = 0;
    mod = 10;
    
    
    
    //Distribution initiale des particules//
    x[0] = -1.0;
    for(i=1;i<N;i++){
        x[i]= x[i-1] - 2.0*x[0]/(N-1);
        printf("%f\n",x[i]);
    }
    
    
    //Calcul de la proba de la config initiale//
    
    P = 1; //initialisation de la proba
    for(i=0;i<N;i++){
        for(j=i+1;j<N;j++){
            P = P * (x[i]-x[j]) * (x[i]-x[j]);
        }
        P = P * exp(-x[i]*x[i]);
    }
    printf("P = %le\n",P);
    
    //Calcul des nouvelles proba avec nouvelles config//
    
    
    for(k=0;k<nbredefois;k++){
        for(i=0;i<N;i++){
            newX = x[i] + 2*(ran2(&idum))-1;
            newP = P * exp(-newX*newX)/exp(-x[i]*x[i]);
            
            for(j=0;j<N;j++){
                if(i==j) continue;
                newP = newP * ((newX-x[j])*(newX-x[j]))/((x[i]-x[j])*(x[i]-x[j]));
            }
            if(P/newP <= 1 | ran2(&idum) <= newP/P){
                compteur = compteur + 1;
                x[i] = newX ;
                P = newP ;
            }
            
        }
        
        if(k%mod==0){
            if(k>=nbredefois/10){ //thermalisation
                
                //TRAJ CLASSIQUE//
                for(i=0 ; i<N ; i++){
                    fprintf(pf2,"%f ",x[i]);
                }
                fprintf(pf2,"\n");
                
                
                for(i=0;i<N;i++){
                    for(j=0;j<M;j++){
                        if(xmin <= x[i] && x[i] <= xmin+(j+1)*pas)
                            fctcomptage[j] = fctcomptage[j] + 1 ;
                    }
                }
            }//endif thermalisation
        }//endif décorrélation
    }//endfor k
    printf("stat d'acceptation de config : %f\n", 1.0*compteur/N/nbredefois);
    
    
    
    
    for(i=0;i<M;i++){

        fprintf(pf23,"%f %f\n",(xmin+i*pas+xmin+(i+1)*pas)/2, fctcomptage[i]/((nbredefois-nbredefois/10)/mod));
        
    }
    fclose(pf2);
    pf2 = fopen("traj.txt","r");
    
    for(i=0;i<((nbredefois-nbredefois/10))/mod; i++){
        for(j=0;j<N;j++){
            
            fscanf(pf2,"%lf ",&x[j]);
            
            //printf("ancienne valeur x[j] : %lf\n",x[j]);
            for(l=0;l<M;l++){
                
                if(xmin+l*pas <= x[j] && x[j] <= xmin+(l+1)*pas){
                    
                    x[j] = fctcomptage[l];
                    //printf("fctcomptage [l] : %lf\n ",fctcomptage[l]);
                    //printf("nouvelle valeur x[j] : %lf\n ",x[j]);
                }//endif
            }//endfor l
            
            fprintf(pf25,"%lf ",x[j]/(double)((nbredefois-nbredefois/10)/mod));
            
        }//endfor j
        //printf("%lf\n",x[0]);
        fscanf(pf2,"\n");
        fprintf(pf25,"\n");
        
        for(j=0;j<N;j++){
            x[j] = x[j]/(double)((nbredefois-nbredefois/10)/mod);
            //printf("x[j] : %lf\n",x[j]);
        }
        

    }//endfor i
    
    //for(l=0;l<M;l++){
    // printf("unihistdensite[l] : %lf\n",unihistdensite[l]);
    //}
    
    fclose(pf25);
    pf25 = fopen("traj_uniforme.txt","r");
    
    for(i=0;i<(nbredefois-nbredefois/10)/mod;i++){
        
        for(j=0;j<N;j++){
            fscanf(pf25,"%lf ",&ranger[j]);
        }
        
        //APPEL DU TRI//
        quickSort(ranger, 0, N-1);
        
        for(j = 0; j < N; j++)
        {
            fprintf(pf26,"%lf ",ranger[j]);
        }
        fprintf(pf26,"\n");
        fscanf(pf25,"\n");
        
        //-------------------//
    }//endfor i
    fclose(pf26);
    
    //--------Premier Voisin-----------//
    
    
    pf26 = fopen("ranger_traj_uniforme.txt","r");

    for(i=0;i<(nbredefois-nbredefois/10)/mod;i++){
        
        for(j=0;j<N;j++){
            fscanf(pf26,"%lf ",&x[j]);
        }
        
        for(j=0;j<N-1;j++){
            premiervoisin[j] = x[j+1]-x[j];
            fprintf(pf27,"%lf ",premiervoisin[j]);
            for(l=0; l<((M+7)/16);l++){
                if(l*3/(double)((M+7)/16)<=premiervoisin[j] && premiervoisin[j]<=(l+1)*3/(double)((M+7)/16)){
                hist_premiervoisin[l] = hist_premiervoisin[l]+1;
                }//endif
            }//endfor l
        }//endfor j
        
        fprintf(pf27,"\n");
        fscanf(pf26,"\n");

    
    }//endfor i
    double compt=0;
    for(i=0; i<(M+7)/16; i++){
        compt = compt + hist_premiervoisin[i];
    }
    printf("compt : %lf\n",compt);
    
    for(l=0;l<(M+7)/16;l++){
        fprintf(pf28,"%lf %lf\n ",(l*3/(double)((M+7)/16)+(l+1)*3/(double)((M+7)/16))/2,hist_premiervoisin[l]/((nbredefois-nbredefois/10)/mod)/(N-1));
    }

    //((nbredefois-nbredefois/10)/mod)/(N-1)
    
    
    fclose(pf2);
    fclose(pf23);
    fclose(pf25);
    fclose(pf26);
    fclose(pf27);
    fclose(pf28);
    
}//end main